<?php
/*
Copyright (c) 2012 http://ramui.com. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
class forum extends clsmain
{
private function show_edit($id='')
{
		$icon_img='../images/icon/forum.gif';
		$icon_txt='Default Icon';
		$hmenu='<li><a href="index.php?qur=11M">Manage Forum</a></li>';
		$script='';
		if(!empty($id)){
			$query="SELECT tf.*, IF(ISNULL(tp.id), 0,COUNT(tp.id)) AS c FROM ".PREFIX."forum tf ";
			$query.="LEFT JOIN ".PREFIX."post tp ON tp.fid = tf.id WHERE tf.id = %u GROUP BY tf.id";
			$query=sprintf($query,$id);
			$result = @$this->con->query($query);
			$row = @$result->fetch_array(MYSQL_ASSOC);
			$hmenu.=(empty($row['c'])? '<li>View post(0)</li>':'<li><a href="index.php?qur=2M6M1M0M0M0M'.$id.'">View post('.$row['c'].')</a></li>');
			$hmenu.='<li><a href="javascript:fwLock()"><span id="fw_lock">'.(((isset($row['locked']))&&($row['locked']=='Y'))? 'Unlock' : 'Lock').'</span></a></li>';
			$hmenu.='<li><a href="javascript:fwDelete()">Delete</a></li>';
			$hmenu.='<li><a href="index.php?qur=10M1">New Category</a></li>';
			$hmenu.='<li><a href="index.php?qur=11M1M">New Forum</a></li>';
			$cat_list=$this->show_listx($id);
			$script='<script type="text/javascript">var fid='.$id.';</script>';
			if(is_file('../icon/'.$row['icon'])){$icon_img='../icon/'.$row['icon'];$icon_txt=$row['icon'];}
		}
		else{$cat_list=$cat_list=$this->show_listx();}
		$this->build_head("Create | Edit Forum",'<script type="text/javascript" src="script/editforum.js"></script>'.$script,$hmenu);
		include "include/editforum.php";
		$this->build_footer();
}
private function delete_forum($id)
{
		@$this->con->query(sprintf("update ".PREFIX."forum set parent = 0, cid = 0 where parent = %u",$id));
		$query=sprintf("update ((select id as xid from ".PREFIX."post where fid = %u and pid = 0) union (select tp.id as xid from ".PREFIX."post tp join (select id from ".PREFIX."post where fid = %u and pid = 0) as t1 on tp.pid = t1.id where tp.pid <> 0)) as t4 join ".PREFIX."upload t2 on t2.pid = t4.xid set t2.pid = 0",$id,$id);
		@$this->con->query($query);
		$query=sprintf("delete t2, t3 from ((select id as xid from ".PREFIX."post where fid = %u and pid = 0) union (select tp.id as xid from ".PREFIX."post tp join (select id from ".PREFIX."post where fid = %u and pid = 0) as t1 on tp.pid = t1.id where tp.pid <> 0)) as t4 join ".PREFIX."post t2 on t2.id = t4.xid left join ".PREFIX."search t3 on t2.id = (if((t3.pid = 0),t3.cid,t3.pid))",$id,$id);
		@$this->con->query($query);
		$query = sprintf("DELETE FROM ".PREFIX."forum WHERE id = %u",$id);
		@$this->con->query($query);
		$loc="Location: index.php?qur=11M";
		@header($loc);
}
private function lock_forum($id)
{
		$query=sprintf("SELECT locked FROM ".PREFIX."forum WHERE id = %u",$id);
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
		if($row['locked']=='Y'){$response='Lock'; $lock='';}
		else{$response='Unlock'; $lock='Y';}
        $query=sprintf("UPDATE ".PREFIX."forum SET locked = '$lock' WHERE id = %u",$id);
        if(@$this->con->query($query)){echo $response;}
        exit;
}
private function edit_forum($id='')
{
		$icon=isset($_POST["icon"])? trim(fw_strip_slashes(rawurldecode($_POST["icon"]))):'';
		$title=trim(fw_strip_slashes(rawurldecode($_POST["title"])));
		$title=htmlspecialchars(($title));
		$title=$this->con->real_escape_string($title);
		$description=trim(fw_strip_slashes(rawurldecode($_POST["description"])));
		$tags=trim(fw_strip_slashes(rawurldecode($_POST["tags"])));
		$description=htmlspecialchars(($description));
		$description=str_replace("\n"," ",str_replace("\r","",$description));
		$sdescription=trim(fw_strip_slashes(rawurldecode($_POST["sdescription"])));
		$tags=htmlspecialchars(($tags));
		if((strlen($description)>250)||(strlen($tags)>250)){exit;}
		$p=trim(fw_strip_slashes(rawurldecode($_POST["parent"])));
		$p=explode('-',$p);
		$cid=(int)$p[0];
		$parent=(int)$p[1];
		if($id&&$parent){if(!$this->verify_parent($id,$parent)){echo 'Unexpected error!';exit;}}
		$description=$this->con->real_escape_string($description);
		$tags=$this->con->real_escape_string($tags);
		$position=$_POST['position'];
		$query=sprintf("SELECT id FROM ".PREFIX."forum WHERE title = '%s' AND cid = %u",$title,$cid);
		$result = @$this->con->query($query);
		$row = @$result->fetch_array(MYSQL_ASSOC);
		if(!empty($row['id'])){
			if((($id)&&($id!=$row['id']))||(!$id)){echo '<span style="color:red;">Error: Forum already exists in selected category!</span>';exit;}
		}
		if($id){$query=sprintf("UPDATE ".PREFIX."forum SET icon = '%s', title = '%s', sdescription = '%s', description = '%s', keywords = '%s', cid = %u, parent = %u, position = %u WHERE id = %u", $icon,$title,$sdescription,$description,$tags,$cid,$parent,$position,$id);}
		else{$query=sprintf("INSERT INTO ".PREFIX."forum (icon, title, sdescription, description, keywords, cid, parent, position) VALUES ('%s', '%s','%s','%s', '%s', %u, %u, %u)",$icon,$title,$sdescription,$description,$tags,$cid,$parent,$position);}
		if(!(@$this->con->query($query))){echo '<span style="color:red;">Error: '.$this->con->error.'</span>';}
		else{
			if($id){echo '<span style="color:green;">Data has been successfully updated</span>';}
			else{$id=$this->con->insert_id;echo 'index.php?qur=11M1M0M'.$id;}
		}
		exit;
}
private function verify_parent($fid,$parent)
{
		$f=array();
		$v=array();
		$query="SELECT id, parent FROM ".PREFIX."forum ORDER BY parent LIMIT 0, 200";
		$result = @$this->con->query($query);
		while($row = @$result->fetch_array(MYSQL_ASSOC)){$f[$row['id']]=$row['parent'];}
		for($i=0;$i<50;$i++){
			if($parent==$fid){return false;}
			$parent=$f[$parent];
			if($parent==0){return true;}
		}
}
private function show_list()
{
        $this->build_head("Manage Forum", '','<li><a href="index.php?qur=11M1">New Forum</a></li><li><a href="index.php?qur=10M1">New Category</a></li>');
		$f=array();
		$fs=array();
		$v=array();
		$query="SELECT id, title, parent, cid, position, locked, icon FROM ".PREFIX."forum ORDER BY parent, cid desc LIMIT 0, 200";
		$result = @$this->con->query($query);
		while($row = @$result->fetch_array(MYSQL_ASSOC)){$f[]=$row;}
		foreach($f as $x){
			if($x['parent']==0){
				if(($x['icon'])&&(is_file('../icon/'.$x['icon']))){$img='<img src="../icon/'.$x['icon'].'" />';}
				else{$img='<img src="../images/icon/forum.gif" />';}
				if($x['locked']=='Y'){$img='<img src="../images/icon/locked.gif" />';}
				if(!isset($fs[$x['cid']])){$fs[$x['cid']]='';}
				$fs[$x['cid']].='<li><table><tr><td>'.$img.'</td><td><a href="index.php?qur=11M1M0M'.$x['id'].'">'.$x['title'].'</a> ('.$x['position'].')</td></tr></table>'.$this->get_child($x['id'],$f,$v).'</li>';
			}
		}
		$str='';
		$query="SELECT id, title, position, icon FROM ".PREFIX."category ORDER BY position Desc LIMIT 0, 50";
		$result = @$this->con->query($query);
		while($row = @$result->fetch_array(MYSQL_ASSOC)){
			if(($row['icon'])&&(is_file('../icon/'.$row['icon']))){$img='<img title="Category Icon" src="../icon/'.$row['icon'].'" alt="C" />';}
			else{$img='<img title="Default Icon" src="../images/icon/category.gif" alt="D" />';}
			$str.='<li><table><tr><td>'.$img.'</td><td><a href="index.php?qur=10M1M'.$row['id'].'">'.$row['title'].'</a> ('.$row['position'].')</td></tr></table>'.(($fs[$row['id']])? '<ul>'.$fs[$row['id']].'</ul>':'').'</li>';
		}
		if($fs[0]){$str.='<li><table><tr><td><img title="Default Icon" src="../images/icon/category.gif" alt="D" /></td><td>No Category:</td></tr></table><ul>'.$fs[0].'</ul></li>';}
		if($str){$str='<ul id="fw_forumlist">'.$str.'</ul>';}
		echo $str.'</div>';
		unset($f,$fs,$v);
        $this->build_footer();
}
private function get_child($id,&$f,&$v)
{
		if(in_array($id,$v)){echo 'Database error!';exit;}
		$v[]=$id;
		$str='';
		foreach($f as $x){
			if($x['parent']==$id){
				if(($x['icon'])&&(is_file('../icon/'.$x['icon']))){$img='<img src="../icon/'.$x['icon'].'" />';}
				else{$img='<img src="../images/icon/forum.gif" />';}
				if($x['locked']=='Y'){$img='<img src="../images/icon/locked.gif" />';}
				$str.='<li><table><tr><td>'.$img.'</td><td><a href="index.php?qur=11M1M0M'.$x['id'].'">'.$x['title'].'</a> ('.$x['position'].')</td></tr></table>'.$this->get_child($x['id'],$f,$v).'</li>';
			}
		}
		if($str){$str='<ul>'.$str.'</ul>';}
		return $str;
}
private function show_listx($fid='')
{
		$f=array();
		$fs=array();
		$v=array();
		$parent=0;
		$cid=0;
		$disabled=false;
		$query="SELECT id, title, parent, cid FROM ".PREFIX."forum ORDER BY parent, cid desc LIMIT 0, 200";
		$result = @$this->con->query($query);
		while($row = @$result->fetch_array(MYSQL_ASSOC)){
			if($row['id']==$fid){$parent=$row['parent'];$cid=$row['cid'];}
			$f[]=$row;
		}
		foreach($f as $x){
			if($x['parent']==0){
				$disabled=($x['id']==$fid);
				if(!isset($fs[$x['cid']])){$fs[$x['cid']]='';}
				$fs[$x['cid']].='<option '.(($disabled)? 'disabled ':(($x['id']==$parent)? 'selected ':'')).'value="0-'.$x['id'].'">|&nbsp;___'.$x['title'].'</option>'.$this->get_childx($x['id'],$f,$v,1,$fid,$disabled,$parent);
			}
		}
		$str='';
		$query="SELECT id, title FROM ".PREFIX."category ORDER BY position Desc LIMIT 0, 50";
		$result = @$this->con->query($query);
		while($row = @$result->fetch_array(MYSQL_ASSOC)){$str.='<option '.(((!$parent)&&($cid==$row['id']))? 'selected ':'').'value="'.$row['id'].'-0">'.$row['title'].'</option>'.($fs[$row['id']]).'<option disabled>'.str_repeat('=',80).'</option>';}
		$str.='<option '.(((!$parent)&&(!$cid))? 'selected ':'').'value="0-0">No Category:</option>'.$fs[0];
		unset($f,$fs,$v);
		return $str;
}
private function get_childx($id,&$f,&$v,$n,$fid,$disabled,$parent)
{
		if(in_array($id,$v)){echo 'Database error!';exit;}
		$v[]=$id;
		$str='';
		$d=false;
		foreach($f as $x){
			if($x['parent']==$id){
				if(!$disabled){$d=($x['id']==$fid);}
				$str.='<option '.((($disabled)||($d))? 'disabled ':(($x['id']==$parent)? 'selected ':'')).'value="0-'.$x['id'].'">'.str_repeat('|&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|___',$n).$x['title'].'</option>'.$this->get_childx($x['id'],$f,$v,$n+1,$fid,$d,$parent);
			}
		}
		return $str;
}
public function get_query($query='')
{
if($this->validate_user()){
    switch ($query[1]) {
        case "6":
            $this->show_list();
        break;
        case "7":
            $this->edit_forum($query[2]);
        break;
        case "1":
            $this->show_edit(isset($query[3])? $query[3]:'');
        break;
        case "2":
            $this->delete_forum($query[2]);
        break;
        case "8":
            $this->lock_forum($query[2]);
        break;
        case "5":
            $this->log_out();
        break;
        default :
            $this->show_list();
    }
}
else{if(($query[1]===6)||($query[1]===1)||empty($query[1])){$this->log_in();}}
}
}
?>