<?php
/*
Copyright (c) 2012 http://ramui.com. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
class page extends clsmain
{
private function show_edit($id='')
{
		$script='<script type="text/javascript" src="script/editpage.js"></script>';
		$hmenu='<li><a href="index.php?qur=1M">Page list</a></li>';
		if($id){
			$query=sprintf("SELECT* FROM ".PREFIX."page WHERE id = %d",$id);
			$result = @$this->con->query($query);
			$row = @$result->fetch_array(MYSQL_ASSOC);
			$hmenu='<li><a href="index.php?qur=1M">Pages</a></li><li><a href="javascript:fwPublish()"><span id="fw_block">'.(($row['publish']=='Y')? 'Block' : 'Publish').'</span></a></li>';
			$hmenu.='<li><a href="javascript:fwDelete()">Delete</a></li><li><a target="_blank" href="'.FORUM_URL.$row['pagename'].'.html" onclick="return fwViewPage()">View</a></li>';
			$script.='<script type="text/javascript">var pageid='.$id.';</script>';}
		$this->build_head("Edit page",$script,$hmenu);
		include "include/editpage.php";
		$this->build_footer();
}
private function delete_page($id)
{
		$query = sprintf("DELETE tp, ts FROM ".PREFIX."page tp LEFT JOIN ".PREFIX."search ts ON tp.id = ts.pageid WHERE tp.id = %u",$id);
		@$this->con->query($query);
		$loc="Location: index.php?qur=1M";
		@header($loc);
}
private function publish($id)
{
		$query="SELECT publish FROM ".PREFIX."page WHERE id = $id";
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
		if($row['publish']=='Y'){$response='Publish'; $publish='';}
		else{$response='Block'; $publish='Y';}
		$query=sprintf("UPDATE ".PREFIX."page tp, ".PREFIX."search ts SET tp.publish = '$publish', ts.publish = '$publish' WHERE tp.id = %d AND tp.id = ts.pageid",$id);
        if(@$this->con->query($query)!=false){echo $response;}
        exit;
}

private function edit_page($id='')
{
		$title=trim(fw_strip_slashes(rawurldecode($_POST["title"])));
		$title=htmlspecialchars(($title));
		$content=trim(fw_strip_slashes(rawurldecode($_POST["content"])));
		$content=($content);
		$content_text=strip_tags($content);
		$dt=time();
		if(strlen($title)>80){exit;}
		$description=trim(fw_strip_slashes(rawurldecode($_POST["description"])));
		$tags=trim(fw_strip_slashes(rawurldecode($_POST["tags"])));
		$description=htmlspecialchars(($description));
		$description=str_replace("\n"," ",str_replace("\r","",$description));
		$tags=htmlspecialchars(($tags));
		if((strlen($description)>250)||(strlen($tags)>250)){exit;}
		if(empty($id)){
			$pagename=trim(fw_strip_slashes(rawurldecode($_POST["pagename"])));
			if(!fw_validate_pagename($pagename)){echo '<span style="color:red;">Error: Invalid pagename!</span>';exit;}
			$query=sprintf("SELECT id FROM ".PREFIX."page WHERE pagename = '%s'",$this->con->real_escape_string($pagename));
			$result=@$this->con->query($query);
			$num_rows = @$result->num_rows;
			if($num_rows!=0){echo '<span style="color:red;">Error: Page already exists!</span>';exit;}
			$query="INSERT INTO ".PREFIX."page(pagename, title, keywords, description, content, date, updated) VALUES ('%s', '%s', '%s', '%s', '%s', $dt, $dt)";
			$query=sprintf($query,$this->con->real_escape_string($pagename),$this->con->real_escape_string($title),$this->con->real_escape_string($tags),$this->con->real_escape_string($description),$this->con->real_escape_string($content));
			if(!(@$this->con->query($query))){echo '<span style="color:red;">Error: '.$this->con->error.'</span>';exit;}
			else{
				$id=$this->con->insert_id;
				$query="INSERT INTO ".PREFIX."search(pageid, title, keywords, description, body) VALUES ($id, '%s', '%s', '%s', '%s')";
				$query=sprintf($query,$this->con->real_escape_string($title),$this->con->real_escape_string($tags),$this->con->real_escape_string($description),$this->con->real_escape_string($content_text));
				@$this->con->query($query);
				echo 'index.php?qur=1M1M'.$id;
			}
		}
		else{
			$query="UPDATE ".PREFIX."page SET title = '%s', keywords = '%s', description = '%s', content = '%s', updated = $dt WHERE id = %d";
			$query=sprintf($query,$this->con->real_escape_string($title),$this->con->real_escape_string($tags),$this->con->real_escape_string($description),$this->con->real_escape_string($content),$id);
			if(!(@$this->con->query($query))){echo '<span style="color:red;">Error: '.$this->con->error.'</span>';exit;}
			else{
				$query=sprintf("UPDATE ".PREFIX."search SET title = '%s', keywords = '%s', description = '%s', body = '%s' WHERE pageid = %d",$this->con->real_escape_string($title),$this->con->real_escape_string($tags),$this->con->real_escape_string($description),$this->con->real_escape_string($content_text),$id);
				@$this->con->query($query);
				echo '<span style="color:green;">Data has been successfully updated</span>';
			}
		}
}
private function show_list($page,$sortColumn,$sortDirection)
{
        $search='';
        $sortDir=((empty($sortDirection))? 'Desc' : 'Asc');
		$sort_arr=array('id','pagename','updated');
        $sortCol=$sort_arr[$sortColumn];
        if(!empty($_GET['SearchFileString'])){$search=htmlspecialchars(fw_strip_slashes($_GET['SearchFileString']));}
        $this->build_head("Page list", '','');
		$query="SELECT id FROM ".PREFIX."page WHERE ";
		$query.="pagename LIKE '%%%s%%' OR keywords LIKE '%%%s%%'";
        $result = @$this->con->query(sprintf($query,$this->con->real_escape_string($search),$this->con->real_escape_string($search)));
        $num_rows = @$result->num_rows;
        $start_count=($page-1)*$this->list_perpage;
        $totalpage=fw_total_page($num_rows, $this->list_perpage);
        $query ="SELECT id, pagename, updated, publish FROM ".PREFIX."page WHERE ";
		$query.="(pagename LIKE '%%%s%%' OR keywords LIKE '%%%s%%') ";
		$query.="ORDER BY $sortCol $sortDir LIMIT ".$start_count.", ".$this->list_perpage;
		$query=sprintf($query,$this->con->real_escape_string($search),$this->con->real_escape_string($search));
        echo '<table id="list"><tr><td width="82%" class="heading" style="border-left:1px solid #d0d0d0;">';
		echo '<a href="index.php?qur=1M6M1M1M1"><img src="images/asc.gif" onmouseover="this.src=\'images/asc-h.gif\'" onmouseout="this.src=\'images/asc.gif\'" /></a>';
		echo '<a href="index.php?qur=1M6M1M1M0"><img src="images/dsc.gif" onmouseover="this.src=\'images/dsc-h.gif\'" onmouseout="this.src=\'images/dsc.gif\'" /></a>Pagename</td>';
		echo '<td class="heading" style="border-right:#888888;">';
		echo '<a href="index.php?qur=1M6M1M2M1"><img src="images/asc.gif" onmouseover="this.src=\'images/asc-h.gif\'" onmouseout="this.src=\'images/asc.gif\'" /></a>';
		echo '<a href="index.php?qur=1M6M1M2M0"><img src="images/dsc.gif" onmouseover="this.src=\'images/dsc-h.gif\'" onmouseout="this.src=\'images/dsc.gif\'" /></a>Modified</td></tr>';
		echo '<tr><td colspan="2"><a title="Create new page" href="index.php?qur=1M1">Create new</a></td></tr>';
        $result = @$this->con->query($query);
        while($row = @$result->fetch_array(MYSQL_ASSOC))
        {
            echo '<tr onMouseOver="this.className=\'highlight\'" onMouseOut="this.className=\'normal\'">';
			$src='<img title="Published" src="images/approved.gif" alt="P" />';$class='approved';
			if($row['publish']!=='Y'){$src='<img title= "Unpublished" src="images/unpublished.gif" alt="U" />';$class='pending';}
            echo '<td>'.$src.'<a class="'.$class.'" href="index.php?qur=1M1M'.$row['id'].'">'.$row['pagename'].'</a></td>';
            //echo '<td style="text-align:center;">'.(($row['publish']=='Y')? '<a target="_blank" href="'.FORUM_URL.$row['pagename'].'.html">View</a>' : '<span style="color:#808080;">View</span>').' | Edit</td>';
            echo '<td>'.gmdate("M d, H:i", $row['updated']).'</td></tr>';
        }

        echo '<tr><td colspan="2"><b>No. of pages:&nbsp;'.$totalpage.'</b>&nbsp;&nbsp;&nbsp;';
        $start=(($page>10)? $page-10 : 1);
        $end=(($totalpage<=21)? $totalpage : $start+20);
        echo(($page>1)? '<a href="index.php?qur=1M6M'.($page-1).'M'.$sortColumn.'M'.$sortDirection.'&SearchFileString='.$search.'">Back</a>&nbsp;' : '<span style="color:#808080;">Back</span>&nbsp;');
        for($p=$start; $p<=$end; $p++){
             if($p==$page){echo '<span style="color:#808080;">['.$p.']</span>&nbsp;';}
             else{echo '[<a href="index.php?qur=1M6M'.$p.'M'.$sortColumn.'M'.$sortDirection.'&SearchFileString='.$search.'">'.$p.'</a>]&nbsp;';}
        }
        echo(($page<$totalpage)? '<a href="index.php?qur=1M6M'.($page+1).'M'.$sortColumn.'M'.$sortDirection.'&SearchFileString='.$search.'">Next</a>&nbsp;' : '<span style="color:#808080;">Next</span>&nbsp;');
        echo '</td></tr>';
        echo '<tr><td colspan="2" style="background:#e0e0e0; padding-bottom:0;">';
        echo '<form name="frmSearchList" style="float:right; margin:0; color:#000000;" onSubmit="return fw_search(\'index.php?qur=1M6M1M0M0\');">';
        echo 'Search file:&nbsp;<input name="txtSearch" style="padding-left:5px; width:180px; font-size:11px; color:#666666;" type="text" value="';
        echo (($search=='')? 'Type few characters...' : $search);
        echo '" size="20" onclick="fw_cleartext(this,\'Type few characters...\');">&nbsp;<input name="Submit" type="button" style="width:80px; font-size:11px; color:#333333;" value="Search" onClick="fw_search(\'index.php?qur=1M6M1M0M0\');"></form></td></tr></table>';
        echo '</div>';
        $this->build_footer();
}
public function get_query($query='')
{
if($this->validate_user()){
    switch ($query[1]) {
        case "6":
            $this->show_list($query[2],$query[3],$query[4]);
        break;
        case "7":
            $this->edit_page($query[2]);
        break;
        case "1":
            $this->show_edit((isset($query[2])? $query[2]:''));
        break;
        case "2":
            $this->delete_page($query[2]);
        break;
        case "3":
            $this->publish($query[2]);
        break;
        case "5":
            $this->log_out();
        break;
        default :
            $this->show_list(1,0,0);
    }
}
else{if(($query[1]===6)||($query[1]===1)||empty($query[1])){$this->log_in();}}
}
}
?>