<?php
/*
Copyright (c) 2012 http://ramui.com. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
class preview
{
private $uid=0;
private $admin=false;
private $site;
public $navigation;
private $con;
function __construct()
{
        $message=$this->connection();
		if((($this->site['blocksite'])&&(!$this->admin))||($message!==true)){include "gb/include/blocksite.php";exit;}
		if(DOCROOT!='/'){$this->navigation='<a href="http://'.getenv('HTTP_HOST').'/">Home</a> ';}
		$this->navigation.='<span>::</span> <a href="'.FORUM_URL.'index.php">'.($this->site['sitename']).'</a>';
}
private function connection()
{
        include '../database/config.php';
		$con=@new mysqli($dbhost,$dbuser,$dbpw,$dbname);
        if(mysqli_connect_errno()){return mysqli_connect_error();}
		$this->con=$con;
 		$con->set_charset("utf8");
        $query  = "SELECT* FROM ".PREFIX."settings";
        $result = $con->query($query);
        $this->site = $result->fetch_array(MYSQL_ASSOC);
		$result->free();
		$this->validate_user();return true;
}
private function validate_user()
{
        $query="SELECT login, session FROM ".PREFIX."admin";
        $result=$this->con->query($query);
        $row=$result->fetch_array(MYSQL_ASSOC);
        $this->admin=(isset($_SESSION['fw_admin'])&&($_SESSION['fw_admin']===$row['session']) && ($_SERVER['REMOTE_ADDR']==$row['login']));
		if(isset($_COOKIE['fw_login'])&&fw_validate_session($_COOKIE['fw_login'])){
            $login=explode('-',$_COOKIE['fw_login']);
			$id=(int)$login[0];
			$session=$login[1];
            $query=sprintf("SELECT session FROM ".PREFIX."user WHERE id = %u AND level='C'",$id);
            $result=$this->con->query($query);
			$row=$result->fetch_array(MYSQL_ASSOC);
            if((!empty($row['session']))&&(md5($row['session'])===$session)){$this->uid=$id;}
		}
		$result->free();
}
public function siteinf(){return($this->site);}
public function get_page_array()
{
		if(isset($_POST['preview'])&&(preg_match('/^(post|comment|news|user|page)$/u', $_POST['preview']))){
			switch($_POST['preview']){
				case 'post':
					$row=$this->post();
				break;
				case 'comment':
					$row=$this->post();
				break;
				case 'user':
					$row=$this->user();
				break;
				case 'news':
					$row=$this->news();
				break;
				case 'page':
					$row=$this->page();
				break;
			}
			if(empty($row['description'])){$row['description']=$this->site['description'];}
			if(empty($row['keywords'])){$row['keywords']=$this->site['keywords'];}
			return $row;
		}
		else{exit;}
}
private function post()
{

		$id=((isset($_GET['id']))&&(preg_match('/^[0-9]{1,5}$/u', trim($_GET['id']))))? (int)($_GET['id']):0;
		$title=isset($_POST["title"])? trim(fw_strip_slashes($_POST["title"])) : 'Post Title';
		$title=xss_cleaner(($title));
		$content=isset($_POST["content"])? trim(fw_strip_slashes($_POST["content"])) : '';
		$max_size=$this->site['postsize'];
		if((strlen($content)>$max_size)||(strlen($title)>80)){echo '<span style="color:red; background-color:white;">Title or Content exceeds limit.</span>';exit;}
		$content=xss_cleaner(($content));
		$autolink=(empty($_POST["fw_parseurls"])? 0 : 1);
		$s=fw_linkcount($content,$autolink);
		if($s>$this->site['linkperpost']){echo '<span style="color:red">Error! Maximum '.$this->site['linkperpost'].' URL allowed</span>';exit;}
		$tags=isset($_POST["tags"])? trim(fw_strip_slashes($_POST["tags"])):'';
		$description=isset($_POST["description"])? trim(fw_strip_slashes($_POST["description"])):'';
		$description=xss_cleaner(($description));
		$description=str_replace("\n"," ",str_replace("\r","",$description));
		$tags=xss_cleaner(($tags));
		if((strlen($description)>250)||(strlen($tags)>250)){echo '<span style="color:red; background-color:white;">Tags or Description length exceeds limit.</span>';exit;}
		$this->navigation.=' <span>::</span> <a href="javascript:location.reload(true)">Reload Preview : '.$title.'</a>';
		$nofollow=(($this->site['nofollow']=='Y')||($this->site['nofollow']=='A'));
		$bb= new bbcode($nofollow,false);
		$content=$bb->format_text($content,$autolink);
		unset($bb);
		$this->add_files($id,$content);
		$str=file_get_contents('../templates/'.$this->site['defaultstyle'].'/structure/post.txt');
		$symbols=array('__&CONTENT__','__&POSTDATE__','__&TITLE__','__&POSTCOUNT__','__&COMMENTCOUNT__','__&USER__','__&DATEOFJOIN__','__&BACKTOPOST__','__&NEWTOPIC__','__&REPLY__','__&CONTACT__','__&REPORT__','__&EDIT__');
		$replacements=array($content,gmdate("M d, Y, H:i",time()),'<a href="../../index.php">'.$title.'</a>','','','Preview','','','','','','','');
		$str=str_replace($symbols,$replacements,$str);
		unset($symbols,$replacements);
		$str=preg_replace("/<signature>(.+)<\/signature>/iUs","", $str);
		$str=preg_replace("/<updated>(.+)<\/updated>/iUs","", $str);
		$row=array('content'=>$str,'description'=>$description,'title'=>$title,'keywords'=>$tags);
		return $row;
}
private function user()
{
		$content=trim(fw_strip_slashes($_POST["signature"]));
		if(strlen($content)>250){echo '<span style="color:red; background-color:white;">Unespected error! Please try again.</span>';exit;}
		if(substr_count($content,"\n")>2){echo '<span style="color:red; background-color:white;">Error! Maximum 3 new line allowed in signature</span>';exit;}
		$s=fw_bb2text($content);
		if(strlen($s)>100){echo '<span style="color:red; background-color:white;">Error! Signature text length must be within 100 characters. Now it is '.strlen($s).'</span>';exit;}
		$autolink=(empty($_POST["fw_parseurls"])? 0 : 1);
		$content=xss_cleaner($content);
		$s=fw_linkcount($content,$autolink);
		if($s>$this->site['linkpersign']){echo '<span style="color:red; background-color:white;">Error! Maximum '.$this->site['linkpersign'].' URL allowed in signature</span>';exit;}
		$nofollow=($this->site['nofollow']=='A');
		$bb= new bbcode($nofollow,true);
		$content=$bb->format_text($content,$autolink);
		unset($bb);
		$content='This signature will appear at the bottom of user post after <b>'.$this->site['signbefore'].'</b> successful post published.<p class="fw_signature"><span>'.str_repeat('_',50).'</span><br />'.$content.'</p>';
		$title='Signature preview';
		$this->navigation.=' <span>::</span> <a href="javascript:location.reload(true)">Reload Preview</a>';

		$str=file_get_contents('../templates/'.$this->site['defaultstyle'].'/structure/post.txt');
		$symbols=array('__&CONTENT__','__&POSTDATE__','__&TITLE__','__&POSTCOUNT__','__&COMMENTCOUNT__','__&USER__','__&DATEOFJOIN__','__&BACKTOPOST__','__&NEWTOPIC__','__&REPLY__','__&CONTACT__','__&REPORT__','__&EDIT__');
		$replacements=array($content,gmdate("M d, Y, H:i",time()),'<a href="../../index.php">'.$title.'</a>','','','Preview','','','','','','','');
		$str=str_replace($symbols,$replacements,$str);
		unset($symbols,$replacements);
		$str=preg_replace("/<signature>(.+)<\/signature>/iUs","", $str);
		$str=preg_replace("/<updated>(.+)<\/updated>/iUs","", $str);
		$row=array('content'=>$str,'title'=>'Signature preview');
		return $row;
}
private function news()
{
		if(!$this->admin){exit;}
		$id=((isset($_GET['id']))&&(preg_match('/^[0-9]{1,5}$/u', trim($_GET['id']))))? (int)($_GET['id']):0;
		$title=isset($_POST["title"])? trim(fw_strip_slashes($_POST["title"])) : 'News Title';
		$title=xss_cleaner(($title));
		$content=isset($_POST["content"])? trim(fw_strip_slashes($_POST["content"])) : '';
		$max_size=$this->site['postsize'];
		if((strlen($content)>$max_size)||(strlen($title)>80)){echo '<span style="color:red; background-color:white;">Title or Content exceeds limit.</span>';exit;}
		$content=xss_cleaner(($content));
		$autolink=(empty($_POST["fw_parseurls"])? 0 : 1);
		$tags=isset($_POST["tags"])? trim(fw_strip_slashes($_POST["tags"])):'';
		$description=isset($_POST["description"])? trim(fw_strip_slashes($_POST["description"])):'';
		$description=xss_cleaner(($description));
		$description=str_replace("\n"," ",str_replace("\r","",$description));
		$tags=xss_cleaner(($tags));
		if((strlen($description)>250)||(strlen($tags)>250)){echo '<span style="color:red; background-color:white;">Tags or Description length exceeds limit.</span>';exit;}
		$this->navigation.=' <span>::</span> <a href="javascript:location.reload(true)">Reload Preview : '.$title.'</a>';
		$nofollow=(($this->site['nofollow']=='Y')||($this->site['nofollow']=='A'));
		$bb= new bbcode($nofollow,false);
		$content=$bb->format_text($content,$autolink);
		unset($bb);
		$this->add_files($id,$content);
		$str=file_get_contents('../templates/'.$this->site['defaultstyle'].'/structure/news.txt');
		$str=str_replace(array('__&TITLE__','__&CONTENT__','__&POSTDATE__'),array($title,$content,gmdate("M d, Y, H:i",time())),$str);
		$str=preg_replace("/<signature>(.+)<\/signature>/iUs","", $str);
		$str=preg_replace("/<updated>(.+)<\/updated>/iUs","", $str);
		$row=array('content'=>$str,'description'=>$description,'title'=>$title,'keywords'=>$tags);
		return $row;
}
private function add_files($id,&$content)
{
		$query="SELECT id, name, compressed, filesize, download FROM ".PREFIX."upload WHERE ";
		if($id==0){$query.='(uid = '.$this->uid.') AND (pid = 0)';}
		else{
			$query.='(pid = '.$id.') OR ';
			if($this->admin){$query.='((pid = 0) AND ((uid = 0) OR (uid = '.$this->uid.')))';}
			else{$query.='((uid = '.$this->uid.') AND (pid = 0))';}
		}
		$result=$this->con->query($query);
		while($row=$result->fetch_array(MYSQL_ASSOC)){
			if($row['compressed']){
				$replacement='<div class="fw_attachment"><a href="../file.php?id='.$row['id'].'">'.$row['name'].'</a>&nbsp;['.@round(($row['filesize']/1024),1).' Kb]<br /><br /><span>**Downloaded '.$row['download'].' time'.(($row['download']>1)? 's':'').'</div>';
			}
			else{
				$replacement='<div class="fw_image"><img title="'.$row['name'].'" src="../file.php?id='.$row['id'].'" alt="'.$row['name'].'" /></div>';
			}
			$content=str_replace('[file]'.$row['name'].'[/file]',$replacement,$content);
		}
}

public function getpage($n)
{
		$query=sprintf("SELECT pagename, title FROM ".PREFIX."page WHERE publish = 'Y' ORDER BY id Desc LIMIT 0,%u",$n);
		$result=$this->con->query($query);
		if($result->num_rows==0){return false;}
		$str='';
		while($row=$result->fetch_array(MYSQL_ASSOC)){
			$link=urlencode($row['pagename']).'.html';
			$anchor=(strlen($row['title'])>32)? substr($row['title'],0,30).'..' : $row['title'];
			$str.='<li><a title="'.$row['title'].'" href="'.$link.'">'.$anchor.'</a></li>';
		}
		return $str;
}
public function getuid()
{
		return(empty($this->uid)? false:$this->uid);
}
public function get_templates()
{
		if(($this->site['userstyle']=='')||(($this->site['userstyle']=='R')&&(!$this->uid))){return false;}
		$list= glob("gb/templates/*",GLOB_ONLYDIR);
		if(count($list)<2){return false;}
		$option='<li><a href="#" onclick="return fwSelectUserStyle(\'-\')">Use Default Style</a></li>';
		foreach ($list as $template){
			$template=str_replace("gb/templates/", "", $template);
			$option.=(($this->site['defaultstyle']==$template)? '<li>'.$template.' (In use)</li>':'<li><a href="#" onclick="return fwSelectUserStyle(\''.addslashes($template).'\')">'.$template.'</a></li>');
		}
		return $option;
}
}
?>