<?php
/*
Copyright (c) 2012 http://ramui.com. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
class post extends clslogin
{
private function add_post($fid)
{
		$dt=time();
		@$this->con->query(sprintf("UPDATE ".PREFIX."user SET edittime = $dt WHERE id = %u",$this->uid));
		$title='Add new post';
		$max=sprintf("%d",$this->site['postsize']);
		$scriptfile='<script type="text/javascript" src="../script/comment.js"></script><script type="text/javascript">var bbCodeEditorID="content";var xid=0;var maxCodeLength='.$max.';</script>';
		$menu=$this->get_menu();
		include "include/head.php";
		if($this->site['allowfile']){
			$this->clear_userfiles();
			$us=$this->get_uploadsettings();
			$upload_list=$this->get_uploadlist($us);
		}
		include "include/add_post.php";
		include "include/footer.html";
}
private function edit_post($id)
{
		$query=sprintf("SELECT tp.* FROM ".PREFIX."post tp JOIN ".PREFIX."forum tf ON tp.fid = tf.id WHERE tp.id = %u AND tp.locked <> 'Y' AND tf.locked <> 'Y' AND tp.publish = 'Y' AND tp.uid = %u",$id,$this->uid);
		$result=@$this->con->query($query);
		$num=@$result->num_rows;
        if(($num<1)||(!($this->site['allowedit']))){$loc=($this->admin)? '../admin/index.php?qur=2M1M'.$id:'../../index.php';@header("Location: $loc");exit;}
		$row =@$result->fetch_array(MYSQL_ASSOC);
		$title=$row['title'];
		$max=sprintf("%d",$this->site['postsize']);
		$menu=$this->get_menu();
		$scriptfile='<script type="text/javascript" src="../script/comment.js"></script><script type="text/javascript">var bbCodeEditorID="content";var xid='.$id.';var maxCodeLength='.$max.';</script>';
		$dt=time();
		@$this->con->query(sprintf("UPDATE ".PREFIX."user SET edittime = $dt WHERE id = %u",$this->uid));
		include "include/head.php";
		if($this->site['allowfile']){
			$this->clear_userfiles();
			$us=$this->get_uploadsettings();
			$upload_list=$this->get_uploadlist($us,$id);
		}
		include "include/add_post.php";
		include "include/footer.html";
}
private function save_post($id='')
{
        $fid=(isset($_POST['fid'])&&(preg_match('/^[0-9]{1,8}$/u', trim($_POST['fid']))))? $_POST['fid'] : 0;
		if($id){$query=sprintf("SELECT tp.updated FROM ".PREFIX."post tp, ".PREFIX."forum tf WHERE tp.id = %u AND tf.id = tp.fid AND tf.locked <> 'Y' AND tp.locked <> 'Y' AND tp.pid = 0",$id);}
		else{$query=sprintf("SELECT id FROM ".PREFIX."forum WHERE id = %u AND locked <> 'Y'",$fid);}
		$result=@$this->con->query($query);
		$num_rows=@$result->num_rows;
		if(empty($num_rows)){exit;}
		$row = @$result->fetch_array(MYSQL_ASSOC);
		if((!$this->site['allowedit'])&&($row['updated']<(time()-900))&&($id)){fw_message(true,'Sorry! this board doesn\'t allow you to edit your post');exit;}
		if((empty($_SESSION['fw_captcha_code']))||(md5($_POST['captcha'])!==($_SESSION['fw_captcha_code']))){
            fw_message(true,'Error! wrong verification code. Please try again.');
            exit;}
		unset($_SESSION['fw_captcha_code']);
		$title=trim(fw_strip_slashes($_POST["title"]));
		$title=xss_cleaner($title);
		$content=trim(fw_strip_slashes($_POST["content"]));
		$content=xss_cleaner($content);
		$max_size=$this->site['postsize'];
		if((strlen($content)>$max_size)||(strlen($title)>80)){fw_message(true,'Title or Content length exceeds limit.');exit;}
		$autolink=(empty($_POST["fw_parseurls"])? 0 : 1);
		$s=fw_linkcount($content,$autolink);
		if($s>$this->site['linkperpost']){fw_message(true,'Error! Maximum '.$this->site['linkperpost'].' URL allowed');exit;}
		$upload_list='';
		$message='';
		if(!$this->verify_uploadcontent($content,$upload_list,$message,$id)){fw_message(true,$message);exit;}
		$content_text=$this->con->real_escape_string(fw_bb2text($content));
		$dt=time();
		$publish=(($this->site['approval']=='A')? 'Y':'');
		$content=$this->con->real_escape_string($content);
		$title=$this->con->real_escape_string($title);
		$description=trim(fw_strip_slashes($_POST["description"]));
		$tags=trim(fw_strip_slashes($_POST["tags"]));
		$description=xss_cleaner(($description));
		$description=str_replace("\n"," ",str_replace("\r","",$description));
		$tags=xss_cleaner(($tags));
		if((strlen($description)>250)||(strlen($tags)>250)){fw_message(true,'Tags or Description length exceeds limit.');exit;}
		$description=$this->con->real_escape_string($description);
		$tags=$this->con->real_escape_string($tags);
		if(empty($id)){
			$query="INSERT INTO ".PREFIX."post(fid, title, description, keywords, uid, content, autolink, publish, updated, date) VALUES (%u, '%s', '%s', '%s', %u, '%s', $autolink, '$publish', $dt, $dt)";
			$query=sprintf($query,$fid,$title,$description,$tags,$this->uid,$content);
			if(!@$this->con->query($query)){fw_message(true,'Error: '.$this->con->error);exit;}
			$pid=$this->con->insert_id;
			if($pid){
				$query=sprintf("INSERT INTO ".PREFIX."search(title, keywords, description, pid, uid, publish, body) VALUES ('%s', '%s', '%s', %d, %d, '$publish', '%s')",$title,$tags,$description,$pid,$this->uid,$content_text);
				@$this->con->query($query);
				if(!empty($upload_list)){$query="UPDATE ".PREFIX."upload SET pid = $pid WHERE id IN $upload_list";@$this->con->query($query);}
				$message='<script>parent.fwPostSuccess('.$pid.',"'.(($this->site['approval']=='A')? 'Your message has been successfully posted':'Your message is waiting for approval').'");</script>';
				}
		}
		else{
			$query="UPDATE ".PREFIX."post tp LEFT JOIN ".PREFIX."search ts ON tp.id = ts.pid SET ";
			$query.="tp.title = '%s', ts.title = '%s', tp.content = '%s', ts.body = '%s', tp.description = '%s', ts.description = '%s', tp.keywords = '%s', ts.keywords = '%s', tp.autolink = $autolink, tp.updated = $dt ";
			$query.="WHERE tp.id = %u";
			$query=sprintf($query,$title,$title,$content,$content_text,$description,$description,$tags,$tags,$id);
			if(!@$this->con->query($query)){fw_message(true,'Error: '.$this->con->error);exit;}
			if(!empty($upload_list)){$query="UPDATE ".PREFIX."upload SET pid = $id WHERE id IN $upload_list";@$this->con->query($query);}
			$message='<script>parent.fwPostSuccess('.$id.',"Your message has been successfully updated");</script>';
		}
		echo $message;exit;
}
public function get_query($qur)
{
		$message='';
		if($this->verify_user($message)){
			switch ($qur[1]){
				case "1":
					$this->add_post($qur[2]);
				break;
				case "2":
					$this->save_post($qur[2]);
				break;
				case "3":
					$this->edit_post($qur[2]);
				break;
				case "5":
					$this->log_out();
				break;
				default:
					@header("Location: index.php");
			}
		}
		else{
			if(($this->admin)&&($qur[1]=="3")){
				$loc="../admin/index.php?qur=2M1M".$qur[2];
				@header("Location: $loc");exit;
			}
			if($qur[1]!="2"){$this->log_in($message);}
			else{fw_message(true,'You have been logged out. Please login again.');exit;}
		}
}
}
?>
